using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace grapplingGun
{
    public class main
    {
        public static void Main()
        {

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Flintlock Pistol"), //item to derive from
                    NameOverride = "Grapple Gun (Pistol) -TGGM", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "This is the default grappling gun. It shoots an hook that can attach to walls, soft object and yes...also people", //new item description
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/pistol.png"), //new item category
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/pistol.png", 1f);
                        Instance.FixColliders();

                        var grapplegun = Instance.AddComponent<GrapplingGunBehaviour>();
                        grapplegun.gunRef = Instance;
                        grapplegun.barrelPosition = new Vector2(0.70f, 0.075f);

                    }
                } 
            );
            
//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"), //item to derive from
                    NameOverride = "Hook -TGGM", //new item name with a suffix to assure it is globally unique
                    DescriptionOverride = "", //new item description
                    CategoryOverride = null, //new item category
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<PhysicalBehaviour>().StabReleaseSpeedModifier = 0.25f;
                        var hook = Instance.AddComponent<HookBehaviour>();
                    }
                } 
            );

        }
    }
}